/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package chenlong.mybatislearn.db.service;

import chenlong.mybatislearn.db.MyBatisSqlSessionFactory;
import chenlong.mybatislearn.db.mapper.RoleMapper;
import chenlong.mybatislearn.db.struct.Role;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.LinkedList;
import java.util.List;
import org.apache.ibatis.session.ResultHandler;
import org.apache.ibatis.session.SqlSession;
import org.apache.log4j.Logger;
import chenlong.mybatislearn.misc.ISelectRoleHandler;
import com.mysql.jdbc.PreparedStatement;

/**
 *
 * @author Administrator
 */
public class RoleService {

    private final Logger logger = Logger.getLogger(RoleService.class);

    public void createRole(Role role) {
        try (SqlSession sqlSession = MyBatisSqlSessionFactory.openSession()) {
            RoleMapper roleMapper = sqlSession.getMapper(RoleMapper.class);
            roleMapper.insertRole(role);
            logger.info("insert roleId = " + role.getRoleId());
        } catch (Exception ex) {
            logger.error("Exception", ex);
        }
    }

    public List<Role> findAllRoles() {
        List<Role> result = null;
        try (SqlSession sqlSession = MyBatisSqlSessionFactory.openSession()) {
            RoleMapper roleMapper = sqlSession.getMapper(RoleMapper.class);
            result = roleMapper.findAllRoles();
        } catch (Exception ex) {
            logger.error("Exception", ex);
        }
        return result;
    }

    public void findAllRolesHandler(ResultHandler handler) {
        try (SqlSession sqlSession = MyBatisSqlSessionFactory.openSession()) {
            sqlSession.select("chenlong.mybatislearn.db.mapper.RoleMapper.findAllRoles", handler);
            System.out.println("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
            sqlSession.select("chenlong.mybatislearn.db.mapper.RoleMapper.findAllRoles", handler);
        } catch (Exception ex) {
            logger.error("Exception", ex);
        }
    }

    public void selectAllRolesByClientCursor(ISelectRoleHandler selectHandler) {
        {
            try (SqlSession session = MyBatisSqlSessionFactory.openSession()) {
                String sql = "SELECT roleId, state, miscData FROM role";
                Connection conn = session.getConnection();
                {
                    PreparedStatement pstmt = (com.mysql.jdbc.PreparedStatement) conn.prepareStatement(sql);//, ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY );
                    List<Role> list = new LinkedList<>();
                    /* 该行非常重要, 开启stream result方式, 否则在大数据量时将使jvm内存溢出; 
                    添加此选项要么读取完ResultSet中的全部数据, 要么必须得调用ResultSet.close(), 否则该连接将不可再用, 在下次使用该连接的时候会抛异常
                     JDBC驱动中的实现如下, 实际上也可以直接使用setFetchSize(Integer.MIN_VALUE);这一行即可
                    
                     public void enableStreamingResults() throws SQLException {
                     synchronized (checkClosed().getConnectionMutex()) {
                     this.originalResultSetType = this.resultSetType;
                     this.originalFetchSize = this.fetchSize;

                     setFetchSize(Integer.MIN_VALUE);
                     setResultSetType(ResultSet.TYPE_FORWARD_ONLY);
                     }
                     } 
                     */
                    pstmt.enableStreamingResults();
                    try (ResultSet rs = pstmt.executeQuery()) {
                        Role role = new Role();
                        int i = 0;
                        while (rs.next()) {
//                            if (i++ > 10) {
//                                break;
//                            }
                            try {
                                role.setRoleId(rs.getString("roleId"));
                                role.setState(rs.getInt("state"));
                                role.setMiscData(rs.getString("miscData"));

                                selectHandler.action(role);
                            } catch (Exception ex) {
                                logger.error("selectAllRoles error!", ex);
                            }
                        }
                    }
                }

//                {
//                    PreparedStatement pstmt = (com.mysql.jdbc.PreparedStatement) conn.prepareStatement(sql);
//                    List<Role> list = new LinkedList<>();
//                    pstmt.enableStreamingResults();
//                    try (ResultSet rs = pstmt.executeQuery()) {
//                        Role role = new Role();
//                        int i = 0;
//                        while (rs.next()) {
//                            if (i++ > 10) {
//                                break;
//                            }
//                            try {
//                                role.setRoleId(rs.getString("roleId"));
//                                role.setState(rs.getInt("state"));
//                                role.setMiscData(rs.getString("miscData"));
//
//                                //selectHandler.action(role);
//                                System.out.println("\t" + role.getRoleId());
//                            } catch (Exception ex) {
//                                logger.error("selectAllRoles error!", ex);
//                            }
//                        }
//                    }
//                }
            } catch (Exception e) {
                logger.error(e.getMessage(), e);
            }
        }
    }

    /**
     * 服务端游标需要在JDBC URL中添加useCursorFetch=tru选项, 例如:
     * <property name="url" value="jdbc:mysql://localhost:3008/mybatislearn?autoReconnect=true&amp;useCursorFetch=true"/>
     *
     * @param selectHandler
     */
    public void selectAllRolesByServerCursor(ISelectRoleHandler selectHandler) {
        {
            try (SqlSession session = MyBatisSqlSessionFactory.openSession()) {
                String sql = "SELECT roleId, state, miscData FROM role";
                Connection conn = session.getConnection();
                {
                    PreparedStatement pstmt = (com.mysql.jdbc.PreparedStatement) conn.prepareStatement(sql);//, ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY );
                    List<Role> list = new LinkedList<>();
                    pstmt.setFetchSize(200); // Server Side Cursor除了需要useCursorFetch=true参数外, 还需要设置此参数
                    ResultSet rs = pstmt.executeQuery();
                    Role role = new Role();
                    int i = 0;
                    while (rs.next()) {
                        if (i++ > 10) {
                            break;
                        }
                        try {
                            role.setRoleId(rs.getString("roleId"));
                            role.setState(rs.getInt("state"));
                            role.setMiscData(rs.getString("miscData"));

                            selectHandler.action(role);
                        } catch (Exception ex) {
                            logger.error("selectAllRoles error!", ex);
                        }
                    }
                }

                {
                    PreparedStatement pstmt = (com.mysql.jdbc.PreparedStatement) conn.prepareStatement(sql);//, ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY );
                    List<Role> list = new LinkedList<>();
                    pstmt.setFetchSize(200);
                    ResultSet rs = pstmt.executeQuery();
                    Role role = new Role();
                    int i = 0;
                    while (rs.next()) {
                        if (i++ > 10) {
                            break;
                        }
                        try {
                            role.setRoleId(rs.getString("roleId"));
                            role.setState(rs.getInt("state"));
                            role.setMiscData(rs.getString("miscData"));

                            //selectHandler.action(role);
                            System.out.println("\t" + role.getRoleId());
                        } catch (Exception ex) {
                            logger.error("selectAllRoles error!", ex);
                        }
                    }
                }
            } catch (Exception e) {
                logger.error(e);
            }
        }
    }
}
